diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java
index 67f4d3df5..d2960163b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java
@@ -9,15 +9,16 @@ import net.minecraft.core.world.type.nether.WorldTypeNetherSkyblock;
 import net.minecraft.core.world.type.overworld.*;
 import net.minecraft.core.world.type.drift.WorldTypeDrift;
 import net.minecraft.core.world.weather.Weathers;
+import org.jetbrains.annotations.NotNull;
 
 public abstract class WorldTypes {
-    public static final WorldType OVERWORLD_EXTENDED = register(
+    public static final @NotNull WorldType OVERWORLD_EXTENDED = register(
             "minecraft:overworld.extended",
             new WorldTypeOverworld(
                     WorldTypeOverworld.defaultProperties("worldType.overworld.extended")
             )
     );
-    public static final WorldType OVERWORLD_DEFAULT = register(
+    public static final @NotNull WorldType OVERWORLD_DEFAULT = register(
             "minecraft:overworld.default",
             new WorldTypeOverworld(
                     WorldTypeOverworld.defaultProperties("worldType.overworld.default")
@@ -25,27 +26,27 @@ public abstract class WorldTypes {
                             .portalBounds(0, 255)
             )
     );
-    public static final WorldType NETHER_DEFAULT = register(
+    public static final @NotNull WorldType NETHER_DEFAULT = register(
             "minecraft:nether.default",
             new WorldTypeNether(
                     WorldTypeNether.defaultProperties("worldType.nether.default")
                         .portalBounds(127, 255)
             )
     );
-    public static final WorldType NETHER_SKYBLOCK = register(
+    public static final @NotNull WorldType NETHER_SKYBLOCK = register(
             "minecraft:nether.skyblock",
             new WorldTypeNetherSkyblock(
                     WorldTypeNether.defaultProperties("worldType.nether.skyblock")
                         .bounds(0, 127, 0)
             )
     );
-    public static final WorldType DRIFT_DEFAULT = register(
+    public static final @NotNull WorldType DRIFT_DEFAULT = register(
             "minecraft:drift.default",
             new WorldTypeDrift(
                     WorldTypeDrift.defaultProperties("worldType.drift.default")
             )
     );
-    public static final WorldType FLAT = register(
+    public static final @NotNull WorldType FLAT = register(
             "minecraft:flat",
             new WorldTypeFlat(
                     WorldType.Properties.of("worldType.flat")
@@ -60,7 +61,7 @@ public abstract class WorldTypes {
                             )
             )
     );
-    public static final WorldType OVERWORLD_FLOATING = register(
+    public static final @NotNull WorldType OVERWORLD_FLOATING = register(
             "minecraft:overworld.floating",
             new WorldTypeOverworldFloating(
                     WorldTypeOverworld.defaultProperties("worldType.overworld.floating")
@@ -68,14 +69,14 @@ public abstract class WorldTypes {
                             .oceanBlock(null)
             )
     );
-    public static final WorldType OVERWORLD_AMPLIFIED = register(
+    public static final @NotNull WorldType OVERWORLD_AMPLIFIED = register(
             "minecraft:overworld.amplified",
             new WorldTypeOverworld(
                     WorldTypeOverworld.defaultProperties("worldType.overworld.amplified")
                             .bounds(0, 255, 64)
             )
     );
-    public static final WorldType OVERWORLD_RETRO = register(
+    public static final @NotNull WorldType OVERWORLD_RETRO = register(
             "minecraft:overworld.retro",
             new WorldTypeOverworldRetro(
                     WorldTypeOverworld.defaultProperties("worldType.overworld.retro")
@@ -85,14 +86,14 @@ public abstract class WorldTypes {
                             .setRetro()
             )
     );
-    public static final WorldType OVERWORLD_ISLANDS = register(
+    public static final @NotNull WorldType OVERWORLD_ISLANDS = register(
             "minecraft:overworld.islands",
             new WorldTypeOverworld(
                     WorldTypeOverworld.defaultProperties("worldType.overworld.islands")
                             .bounds(0, 255, 160)
             )
     );
-    public static final WorldType OVERWORLD_WINTER = register(
+    public static final @NotNull WorldType OVERWORLD_WINTER = register(
             "minecraft:overworld.winter",
             new WorldTypeOverworld(
                     WorldTypeOverworld.defaultProperties("worldType.overworld.winter")
@@ -104,7 +105,7 @@ public abstract class WorldTypes {
                             .portalBounds(0, 255)
             )
     );
-    public static final WorldType OVERWORLD_HELL = register(
+    public static final @NotNull WorldType OVERWORLD_HELL = register(
             "minecraft:overworld.hell",
             new WorldTypeOverworldHell(
                     WorldType.Properties.of("worldType.overworld.hell")
@@ -121,14 +122,14 @@ public abstract class WorldTypes {
                             .defaultWeather(Weathers.OVERWORLD_HELL_CLEAR)
             )
     );
-    public static final WorldType OVERWORLD_WOODS = register(
+    public static final @NotNull WorldType OVERWORLD_WOODS = register(
             "minecraft:overworld.woods",
             new WorldTypeOverworldWoods(
                     WorldTypeOverworld.defaultProperties("worldType.overworld.woods")
                             .defaultWeather(Weathers.OVERWORLD_WOODS_CLEAR)
             )
     );
-    public static final WorldType OVERWORLD_PARADISE = register(
+    public static final @NotNull WorldType OVERWORLD_PARADISE = register(
             "minecraft:overworld.paradise",
             new WorldTypeOverworldParadise(
                     WorldTypeOverworld.defaultProperties("worldType.overworld.paradise")
@@ -140,7 +141,7 @@ public abstract class WorldTypes {
                             .portalBounds(0, 255)
             )
     );
-    public static final WorldType OVERWORLD_INLAND = register(
+    public static final @NotNull WorldType OVERWORLD_INLAND = register(
             "minecraft:overworld.inland",
             new WorldTypeOverworldInland(
                     WorldTypeOverworld.defaultProperties("worldType.overworld.inland")
@@ -148,7 +149,7 @@ public abstract class WorldTypes {
                             .oceanBlock(null)
             )
     );
-    public static final WorldType OVERWORLD_CLASSIC = register(
+    public static final @NotNull WorldType OVERWORLD_CLASSIC = register(
             "minecraft:overworld.classic",
             new WorldTypeOverworldClassic(
                     WorldTypeOverworld.defaultProperties("worldType.overworld.classic")
@@ -158,7 +159,7 @@ public abstract class WorldTypes {
                             .setRetro()
             )
     );
-    public static final WorldType OVERWORLD_INDEV = register(
+    public static final @NotNull WorldType OVERWORLD_INDEV = register(
             "minecraft:overworld.indev",
             new WorldTypeOverworldIndev(
                     WorldTypeOverworld.defaultProperties("worldType.overworld.indev")
@@ -168,7 +169,7 @@ public abstract class WorldTypes {
                             .setRetro()
             )
     );
-    public static final WorldType OVERWORLD_SKYBLOCK = register(
+    public static final @NotNull WorldType OVERWORLD_SKYBLOCK = register(
             "minecraft:overworld.skyblock",
             new WorldTypeOverworldSkyblock(
                     WorldTypeOverworld.defaultProperties("worldType.overworld.skyblock")
@@ -176,14 +177,14 @@ public abstract class WorldTypes {
                         .portalBounds(0, 255)
             )
     );
-    public static final WorldType OVERWORLD_BETA_173 = register(
+    public static final @NotNull WorldType OVERWORLD_BETA_173 = register(
             "minecraft:overworld.beta_173",
             new WorldTypeOverworldB173(
                     WorldTypeOverworld.defaultProperties("worldType.overworld.beta_173")
                             .bounds(0, 127, 64)
             )
     );
-    public static final WorldType EMPTY = register(
+    public static final @NotNull WorldType EMPTY = register(
             "minecraft:empty",
             new WorldTypeEmpty(
                     WorldType.Properties.of("worldType.empty")
@@ -192,7 +193,7 @@ public abstract class WorldTypes {
                             .allowRespawn()
             )
     );
-    public static final WorldType DEBUG = register(
+    public static final @NotNull WorldType DEBUG = register(
             "minecraft:debug",
             new WorldTypeDebug(
                     WorldType.Properties.of("worldType.debug")
@@ -202,7 +203,7 @@ public abstract class WorldTypes {
             )
     );
 
-    public static WorldType register(String key, WorldType worldType) {
+    public static @NotNull WorldType register(final @NotNull String key, final @NotNull WorldType worldType) {
         Registries.WORLD_TYPES.register(key, worldType);
 
         return worldType;
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
index cb7050017..04e0c4070 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
@@ -11,6 +11,7 @@ import net.minecraft.core.world.generate.chunk.perlin.overworld.ChunkGeneratorOv
 import net.minecraft.core.world.season.Seasons;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.weather.Weather;
+import org.jetbrains.annotations.NotNull;
 
 public class WorldTypeOverworld
         extends WorldType {
@@ -25,7 +26,7 @@ public class WorldTypeOverworld
         world.setWorldTime(72000 + 3000);
     }
 
-    public static Properties defaultProperties(String translationKey) {
+    public static @NotNull Properties defaultProperties(@NotNull String translationKey) {
         return Properties.of(translationKey)
                 .brightnessRamp(createLightRamp())
                 .seasonConfig(SeasonConfig.builder()
diff --git a/game/core/src/main/resources/lang/en_US/options.lang b/game/core/src/main/resources/lang/en_US/options.lang
index 4cac9c938..55afa489d 100644
--- a/game/core/src/main/resources/lang/en_US/options.lang
+++ b/game/core/src/main/resources/lang/en_US/options.lang
@@ -179,6 +179,7 @@ options.chatVisibility.show_all=Always Show
 options.chatVisibility.show_when_chatting=Only Show When Chatting
 options.chatVisibility.never_show=Never Show
 options.developerMode=Developer Mode
+options.viewSupportMode=View Supports
 options.devModels=Show Developer Models
 options.forceOnscreenKeyboard=Force On Screen Keyboard
 options.enableHolidayTextures=Enable Holiday Textures
diff --git a/util/datagen/build.gradle.kts b/util/datagen/build.gradle.kts
index 70d2ee8d4..9f0a275e2 100644
--- a/util/datagen/build.gradle.kts
+++ b/util/datagen/build.gradle.kts
@@ -21,7 +21,7 @@ val output by configurations.creating
 //region Tasks
 val runDatagen by tasks.registering(JavaExec::class) {
     group = "bta.generator"
-    val datagenDir = project.layout.buildDirectory.dir("generated/sources/datagen/resources")
+    val datagenDir = project.layout.buildDirectory.dir("resources/main")
     val recipesDir = datagenDir.get().file("recipes")
     outputs.dir(datagenDir)
 
